
* DKdis01.do - Exercises, Session 6
* Factor analysis of aggregate party choice

set more off

* Set local directory (the folder with all files for Exercise 06)
cd H:\UNDERV\SEMINAR\F12\Exercises\06

* Load the data file
use DKdistricts.dta, clear

* Preparing data
*****************

* Inspect DP98
sum dpoe98-votdp98

* Compute percent of all voters
* for a single party
gen pdpoe98 = dpoe98/votdp98*100
drop pdpoe98

* for all parties
foreach v of varlist dpoe98 dpf98 dpu98 dpa98 dpb98 dpd98 dpq98 dpc98 /*
  */ dpv98 dpo98 dpz98 xdp98 spldp98 absdp98 {
gen p`v' = `v'/votdp98*100 
  }
sum pdpoe98-pabsdp98

* Weighted percentages
sum pdpoe98-pabsdp98 [aw=votdp98]

* Compute logit shares
* for a single party
gen ldpoe98 = ln(pdpoe98/(100-pdpoe98))
drop ldpoe98

* in case percent is equal to 0 or 100
gen temp = pdpoe98
replace temp = 0.5/votdp98*100 if dpoe98 == 0
replace temp = (votdp98-0.5)/votdp98*100 if dpoe98 == votdp98
gen ldpoe98 = ln(temp/(100-temp))
drop temp
drop ldpoe98

* for all parties
foreach v of varlist dpoe98 dpf98 dpu98 dpa98 dpb98 dpd98 dpq98 dpc98 /*
  */ dpv98 dpo98 dpz98 xdp98 spldp98 absdp98 {
gen l`v' = ln(p`v'/(100-p`v')) 
  }
sum ldpoe98-labsdp98 [aw=votdp98]

* Compute percentages and logits for DP 2001
********************************************

* Inspect DP01
sum dpoe01-votdp01

* Compute percentages for all parties
foreach v of varlist dpoe01 dpf01 dpa01 dpb01 dpd01 dpq01 dpc01 /*
  */ dpv01 dpo01 dpz01 xdp01 spldp01 absdp01 {
gen p`v' = `v'/votdp01*100 
  }
sum pdpoe01-pabsdp01 [aw=votdp01]

* Compute logits for all parties
foreach v of varlist dpoe01 dpf01 dpa01 dpb01 dpd01 dpq01 dpc01 /*
  */ dpv01 dpo01 dpz01 xdp01 spldp01 absdp01 {
gen l`v' = ln(p`v'/(100-p`v')) 
  }
sum ldpoe01-labsdp01 [aw=votdp01]

* Factor analysis
*****************

obliraw ldpoe98-ldpz98 labsdp98 ldpoe01-ldpz01 labsdp01 [aw=votdp01], factors(2)

* The following procedure only available in Stata version 8
version 8
greigen 

