
* Move gpfobl.ado and gpfobl.hlp files to C:\ado\personal\g

program define obliraw, eclass
version 8
syntax varlist [aweight/], FActors(integer) [GAmma(real 0.0)]
if "`exp'" != "" local wgt "[`weight'=`exp']"
local NFac = `factors'


di
di "{title:Oblique rotation of raw components}"

if `:word count `varlist''< `NFac' {
  di "{error}More factors than variables not allowed"
  exit
}

quietly matrix accum  M_or = `varlist' `wgt' , deviations noconstant 
mat V_or = vecdiag(M_or)'
local rows = rowsof(V_or)
local units = r(N)
forvalues i = 1/`rows' {
  matrix V_or[`i',1] = sqrt(V_or[`i',1]/(`units'-1))
  }

*di
*di "{text}Standard Deviations"
*mat colnames V_or = "SD"
*mat list V_or, format(%5.4f) noheader
local varnames : rownames(V_or)

di
di "{text}Raw principal components"
di

* Principal component analysis with covariances
pca `varlist' `wgt', factors(`NFac') covariance means

* Get the loadings (eigenvectors returned by pca)
mat A_or=get(Ld)

*Create diagonal matrix with sqrt of two first eigenvalues.
local FacNames
matrix NFacEig = J(`NFac',`NFac',0)
forvalues i = 1/`NFac' {
  local FacNames = "`FacNames' F`i'"
  mat NFacEig[`i',`i'] = sqrt(r(lambda`i'))
}
mat colnames NFacEig = `FacNames'

* Compute the raw component loadings
mat B_or = A_or*NFacEig
mat rownames B_or = `varnames'
di
di "{text}Raw Components"
mat list B_or, format(%5.4f) noheader

*Create matrix for rescaled component loadings
matrix C_or=J(`rows',`NFac',0)

forvalues i = 1/`rows' {
  forvalues j = 1/`NFac' {
    matrix C_or[`i',`j'] = B_or[`i',`j']/V_or[`i',1]
  }
}
mat rownames C_or = `varnames'
mat colnames C_or = `FacNames'
di
di "{text}Rescaled Components"
mat list C_or, format(%5.4f) noheader

gpfobl C_or, oblimin(`gamma')

matrix A_or=L

* Drop matrices used by gpfobl
mat drop phi Y Gp TG csum G Tmat Gq F L2 N L Ti Tt v X2 X A A0
 
matrix D_or=J(`rows',`NFac',0)

forvalues i = 1/`rows' {
  forvalues j = 1/`NFac' {
    matrix D_or[`i',`j'] = A_or[`i',`j']*V_or[`i',1]
  }
}
mat rownames D_or = `varnames'
mat colnames D_or = `FacNames'
di
di "{text}Raw rotated Components"
mat list D_or, format(%5.4f) noheader

ereturn matrix Ld_or D_or

mat drop M_or V_or NFacEig A_or B_or C_or
end

